.486P

INCLUDE STRUCT.INC
INCLUDE COSTANT.INC



Start_SEG 	SEGMENT PUBLIC USE32 'CODE'
		ASSUME CS:Start_SEG,DS:Start_Data

Start_Limit_Low	EQU $

Start:					      ; your code comes here
		STI			      ; better put it but there is
					      ; the safer.

		INT 57
		INT 52

		MOV ECX,0
		MOV EBX,OFFSET Real_Init      ; 537 773 volte al secondo
		MOV EDX,SEG REAL_SEG          ; su P 133.
		INT 50




		INT 52			      ; Getch

		MOV ECX,1
		MOV EBX,OFFSET Real_Init      ; Restore Video
		MOV EDX,SEG REAL_SEG
		INT 50

		XOR EAX,EAX		      ; Locate 0,0
		INT 55

		MOV EAX,SelStart_Data
		MOV DS,EAX
		MOV ESI,OFFSET End	      ; Print End Message
		INT 54

		MOV AL,0		      ; EXIT CODE 1
		INT 48


Start_Limit	EQU $ - Start_Limit_Low - 1

Start_SEG 	ENDS

Start_Data	SEGMENT PUBLIC 8 USE32 'DATA'
StartData_Limit_Low	EQU	$
Buffer          DB 1000 DUP (0)
Pal		DB 769 DUP (0)
End		DB 'Thanks for watching my ',10,12,'demo',10,7,'.',13,13,0

StartData_Limit         EQU $ - StartData_Limit_Low - 1
Start_Data	ENDS




REAL_SEG 	SEGMENT PUBLIC USE16 'CODE'
		ASSUME CS:REAL_SEG,DS:REAL_DATA,SS:REAL_DATA
		ASSUME ES:NOTHING,FS:NOTHING,GS:NOTHING


Real_Init:
		CMP CX,0
		JNE SHORT RES


	mov ax,19
	int 10h


	MOV EAX,Start_Data
	SHL EAX,4
	ADD EAX,OFFSET Pal
	MOV EDI,EAX
	MOV AX,CS
	MOV DS,AX
	MOV DX,OFFSET Nome_p
	CALL Read_File

	CALL Svga_SetPalette


	MOV EDI,0A0000H
	MOV AX,CS
	MOV DS,AX
	MOV DX,OFFSET Nome
							; DS:DX Nome
	CALL Read_File                                  ; EDI DEST


	RETF
Nome	db	'intro2.pix',0
Nome_p	db	'intro2.PAL',0

RES:		MOV AX,3
		INT 10H
		RETF



Read_File	PROC NEAR			; AX, ECX, BX,dx,ESI,EDI
						; ECX =BYTES LETTI
	PUSH DS
	PUSH ES
	XOR ECX,ECX
	MOV AX,3D00H
	INT 21H
	JC SHORT Error
	MOV BX,AX		        	; BX = Handle
	MOV AX,Kernel_Data
	MOV DS,AX

;	MOV DX,LOW_START_SEG

	MOV DX,SEG Start_Data	;PROBLEM
	MOV DS,DX
	XOR DX,DX                       	; DS:DX Buffer
	MOV ES,CX				; ES:EDI Dest
	PUSH ECX				; STACK Bytes letti

Rip_Lettura:

	MOV AH,3FH
	MOV CX,900
	INT 21H
	MOVZX EAX,AX				; EAX bytes letti
	MOV ECX,EAX
	SHR ECX,2				; ECX DWORD Lette

	XOR ESI,ESI                             ; DS:0000 -> ES:EDI
	REP
	DB 67H
	MOVSD

	POP ECX
	ADD ECX,EAX
	PUSH ECX
	CMP AX,900
	JE SHORT Rip_Lettura

	MOV AH,3EH
	INT 21H
	POP ECX
Error:
	POP ES
	POP DS
	RET

Read_File	ENDP

Svga_SetPalette	PROC NEAR
	MOV AX,Start_Data
	MOV DS,AX
	MOV BX,OFFSET Pal
	XOR CL,CL
PAL_RIP:
	MOV DX,03C8h
	MOV AL,CL
	OUT DX,AL
	MOV DX,03C9h
	MOV AL,[BX]
	OUT DX,AL
	INC BX
	MOV AL,[BX]
	OUT DX,AL
	INC BX
	MOV AL,[BX]
	OUT DX,AL
	INC BX
	INC CL
	JNZ SHORT PAL_RIP
	RET
Svga_SetPalette ENDP

REAL_SEG 	ENDS



REAL_DATA	SEGMENT PUBLIC USE16 'DATA'
REAL_DATA	ENDS


END
